Attribute VB_Name = "mdlMP3"
Option Explicit

' Modul MP3-Play and Stop via API
' Modul WaV

' zunchst die bentigte API-Deklaration
Private Declare Function mciSendString Lib "winmm.dll" _
  Alias "mciSendStringA" (ByVal lpszCommand As String, _
  ByVal lpszReturnString As String, _
  ByVal cchReturnLength As Long, _
  ByVal hwndCallback As Long) As Long

Private Declare Function GetShortPathName Lib "kernel32" _
  Alias "GetShortPathNameA" (ByVal lpszLongPath As String, _
  ByVal lpszShortPath As String, _
  ByVal cchBuffer As Long) As Long
  

Private Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long

    Sub Sound(WAVDatei As String)
    If SoundActive = True Then
        Dim rc As Long
            rc = sndPlaySound(WAVDatei, 1)
    End If
    End Sub

' MP3-Datei abspielen
Public Function MP3_Play(ByVal sFile As String, _
  ByVal sAlias As String) As Boolean
If (MenuActive = True And (sFile = "menuchange.mp3" Or sFile = "menuchange2.mp3")) Or (MusicActive = True And sFile = "bg.mp3") Then

      Dim bResult As Boolean
    
      ' Dateinamen in DOS 8.3 Format, da z.B. Sonderzeichen
      ' wie Leerzeichen Probleme machen
      Dim sBuffer As String
      Dim lResult As Long
      
      sBuffer = Space$(255)
      lResult = GetShortPathName(sFile, sBuffer, Len(sBuffer))
      
      If lResult <> 0 Then
        sFile = Left$(sBuffer, InStr(sBuffer, vbNullChar) - 1)
        
        ' MCI ffnen
        lResult = mciSendString("open " & sFile & _
          " type MPEGVideo alias " & sAlias, 0, 0, 0)
        
        If lResult = 0 Then
          ' MP3 abspielen
          If mciSendString("play " & sAlias & _
            " from 0", 0, 0, 0) = 0 Then
            bResult = True
          End If
        End If
      End If
      
      MP3_Play = bResult
End If
End Function

' Wiedergabe stoppen und MCI schlieen
Public Sub MP3_Stop(ByVal sAlias As String)
  mciSendString "stop " & sAlias, 0, 0, 0
  mciSendString "close " & sAlias, 0, 0, 0
End Sub

